#!/bin/python
import urllib.request, os, sys, re, time, smtplib, mimetypes
from email.message import Message
from email.mime.audio import MIMEAudio
from email.mime.base import MIMEBase
from email.mime.image import MIMEImage
from email.mime.multipart import MIMEMultipart
from email.mime.text import MIMEText


def main():
    if not os.path.isfile("log.txt"):
        f=open('log.txt',"w+")
        f.close()
#fetch main page
    url="http://ditesbonjouralamadame.tumblr.com"
    f = urllib.request.urlopen(url)
    page=f.read(10000).decode('utf-8')

    #Search real link
    artSearch = re.search('1,"url":"(.+?)"}]',page)
    if artSearch:
        art = artSearch.group(1)
    url=art.replace("\\","")

    #Search Img link
    f = urllib.request.urlopen(url)
    page=f.read(10000).decode('utf-8')

    #set img adresse in imgURL
    imgSearch = re.search('witter:image" content="(.+?)" /><',page)
    if imgSearch:
        imgURL = imgSearch.group(1)

    checkLog=open("log.txt","r")
    if checkLog.readline() != imgURL:
        checkLog.close()
        #Write img
        f = urllib.request.urlopen(imgURL)
        THEPICTURE=f.read()

        imgName=time.strftime("%d-%m-%Y")+".png"
        img=open(imgName,"wb")
        img.write(THEPICTURE)
        img.close()
        sendMail(imgName)
        log=open("log.txt", 'w+')
        log.write(imgURL)
        log.close()
    else:
        checkLog.close()


def sendMail(imgFileName):
    sendMsg = MIMEMultipart()
    mailinglist=open("mailinglist.txt","r")
    sendTo =[]
    #Set Subject here
    From="just@awesome.pic"
    sendMsg['From'] = From
    sendMsg['Subject'] = "[NSFW] Pic of the day"
    #attach text
    message="""
    Hi,
    Just sharing the pic of the day on http://bonjourmadame.fr.
    Because it's beautiful.
    Have a good day :).
    """
    msg = MIMEText(message)
    msg.add_header('Content-Disposition', 'attachment')
    sendMsg.attach(msg)
    #attach img
    fp = open(imgFileName, 'rb')
    msg = MIMEImage(fp.read())
    fp.close()
    msg.add_header('Content-Disposition', 'attachment')
    sendMsg.attach(msg)

    #read all mailinglist
    line=mailinglist.readline()
    while line:
        sendTo.append(line)
        line=mailinglist.readline()

    smtpserver = smtplib.SMTP("127.0.0.1",25)
    smtpserver.ehlo()
    smtpserver.ehlo
    
    for contact in sendTo:
        finalMsg=sendMsg.as_string()
        smtpserver.sendmail(From, contact, finalMsg)
        print("Sent to "+contact+" done")
    print("All done. :)")
    smtpserver.close()

    os.remove(imgFileName)

if __name__ == "__main__":
    main()
